<template>
  <a-modal
    centered
    class="promotionList-basicInfo-modal"
    :footer="null"
    :maskClosable="false"
    title="规则设置"
    v-model="isShow"
    @cancel="isShow=false"
    width="70%">
    <a-spin :spinning="spinning" tip="Loading...">
      <a-form-model
        id="promotionList-basicInfo-form"
        ref="ruleForm"
        :model="form"
        :rules="rules"
        :label-col="formItemLayout.labelCol"
        :wrapper-col="formItemLayout.wrapperCol" >
        <a-form-model-item label="规则简称" prop="description">
          <a-input
            size="small"
            id="promotionList-description"
            v-model.trim="form.description"
            allowClear
            placeholder="请输入规则简称（最多20个字符）"
            :maxLength="20"></a-input>
        </a-form-model-item>
        <a-form-model-item label="规则门槛" prop="gateFlag">
          <a-radio-group v-model="form.gateFlag" button-style="solid" size="small" @change="changeGateFlag">
            <a-radio-button value="1">
              有
            </a-radio-button>
            <a-radio-button value="0">
              无
            </a-radio-button>
          </a-radio-group>
          <div v-if="form.gateFlag && form.gateFlag === '1'">
            <v-select
              size="small"
              style="width:60%;"
              v-model="form.gateType"
              id="promotionList-gateType"
              code="PROMOTION_GATE_TYPE"
              placeholder="请选择"
              @change="changeGateTypeFlag"
              allowClear></v-select>
            <div v-if="form.gateType==='RATIO_AMOUNT'">
              购买门槛产品金额 <a-input-number v-model="form.gateAmount" :min="0" :max="999999" :precision="2" size="small"/> %作为配额
              <a-tooltip title="如：填写100%，则购买10000元门槛产品，可享受10000配额购买正价产品，根据门槛金额动态调整配额">
                <a-icon type="question-circle" theme="filled" :style="{ fontSize: '14px', color: 'gray' }"/>
              </a-tooltip>
            </div>
            <div v-if="form.gateType==='MIN_AMOUNT'">
              购买门槛产品满最低金额 <a-input-number v-model="form.gateAmount" :max="999999" :min="0" :precision="2" size="small"/>元，不限制配额。
            </div>
            <div class="ruleDescList" v-if="form.gateType==='FIXED_AMOUNT'">
              购买满
              <a-input-number v-model="form.gateAmount" :min="0" :max="999999" :precision="2" size="small"/>
              元门槛产品，可使用
              <a-input-number v-model="form.quotaAmount" :min="0" :max="999999" :precision="2" size="small"/>
              元配额，采购规则中的正价商品（配额算销售额)
            </div>
          </div>
        </a-form-model-item>
        <a-form-model-item label="满赠规则" prop="regularAmount">
          <div class="ruleDescList">
            <!-- <a-select default-value="1" v-model="form.regularSameFlag" style="width: 100px" size="small">
              <a-select-option value="1">
                同款
              </a-select-option>
              <a-select-option value="0">
                不同款
              </a-select-option>
            </a-select> -->
            购买满
            <a-input-number
              v-model="form.regularAmount"
              @blur="calculatePrice"
              :min="0"
              :step="1"
              :precision="2"
              :max="999999"
              size="small"/>
            元正价产品，送
            <a-input-number
              v-model="form.giveAmount"
              @blur="calculatePrice"
              :min="0"
              :step="1"
              :max="999999"
              :precision="2"
              size="small"/>
            元（{{ scaleNum }}%促销品采购额）
          </div>
        </a-form-model-item>
        <a-form-model-item label="金额叠加" prop="accrualFlag">
          <a-radio-group v-model="form.accrualFlag" button-style="solid" size="small">
            <a-radio-button value="1">
              是
            </a-radio-button>
            <a-radio-button value="0">
              否
            </a-radio-button>
          </a-radio-group>
          <span style="color:gray;">（如：满1000送200，金额叠加则：满2000送400，以此类推）</span>
        </a-form-model-item>
        <a-form-model-item prop="minOrderFlag" label="订单起订金额">
          <a-select default-value="1" v-model="form.minOrderFlag" style="width: 160px" size="small">
            <a-select-option value="0">
              不限
            </a-select-option>
            <a-select-option value="1">
              限制
            </a-select-option>
          </a-select>
          <a-input-number
            v-show="form.minOrderFlag && form.minOrderFlag=='1'"
            size="small"
            style="margin-left:10px;width:300px;"
            v-model="form.minOrderAmount"
            :min="0"
            :step="1"
            :max="999999"
            :precision="2"
            placeholder="请输入金额"/>
        </a-form-model-item>
        <a-form-model-item prop="upperLimitFlag" label="活动经费上限">
          <a-select default-value="1" v-model="form.upperLimitFlag" style="width: 160px" size="small">
            <a-select-option value="0">
              不限
            </a-select-option>
            <a-select-option value="1">
              限制
            </a-select-option>
          </a-select>
          <a-input-number
            v-show="form.upperLimitFlag&&form.upperLimitFlag=='1'"
            size="small"
            style="margin-left:10px;width:300px;"
            v-model="form.upperLimitAmount"
            :min="0"
            :step="1"
            :max="999999"
            :precision="2"
            placeholder="请输入金额"/>
        </a-form-model-item>
        <a-form-model-item label="采购额适用范围" prop="scopeFlag">
          <a-radio-group v-model="form.scopeFlag" button-style="solid" size="small">
            <a-radio-button value="0">
              部分产品
            </a-radio-button>
            <a-radio-button value="1">
              全部产品
            </a-radio-button>
          </a-radio-group>
        </a-form-model-item>
      </a-form-model>
      <a-card size="small" :bordered="false" class="pages-wrap">
        <div class="flex">
          <a-radio-group v-model="chooseVal" button-style="solid" size="small">
            <a-radio-button value="a" v-show="form.gateFlag==='1'">
              门槛产品
            </a-radio-button>
            <a-radio-button value="b">
              正价产品
            </a-radio-button>
            <a-radio-button value="c" v-show="form.scopeFlag==='0'">
              促销产品
            </a-radio-button>
          </a-radio-group>
          <a-button
            size="small"
            type="link"
            class="button-info"
            @click="openGuideModal=true"
            id="promotionList-edit-btn">+导入产品</a-button>
        </div>
        <div v-show="chooseVal=='a'"><tableType1 ref="cillProduct"></tableType1></div>
        <div v-show="chooseVal=='b'"><tableType1 ref="normalPriceProduct"></tableType1></div>
        <div v-show="chooseVal=='c'"><tableType2 ref="offerProduct"></tableType2></div>
      </a-card>
      <div class="btn-cont">
        <a-button id="promotionList-basicInfo-modal-back" @click="isShow = false">取消</a-button>
        <a-button style="margin-left: 15px;" type="primary" id="promotionList-modal-save" @click="handleSave">确定</a-button>
      </div>
    </a-spin>
    <!-- 导入产品 -->
    <importGuideModal goodFlag="1" :openModal="openGuideModal" @close="closeGuideModel" @ok="hanldeOk" />
  </a-modal>
</template>

<script>
import { commonMixin } from '@/utils/mixin'
import { VSelect } from '@/components'
import tableType1 from './tableType1.vue'
import tableType2 from './tableType2.vue'
import { promotionSave, getRuleDetail } from '@/api/promotion'
import ImportGuideModal from './importGuideModal.vue'
export default {
  name: 'PromotionListBasicInfoModal',
  mixins: [commonMixin],
  components: { VSelect, tableType1, tableType2, ImportGuideModal },
  props: {
    openModal: { //  弹框显示状态
      type: Boolean,
      default: false
    },
    promotionSn: {
      type: [Number, String],
      default: ''
    },
    itemSn: {
      type: [Number, String],
      default: ''
    }
  },
  data () {
    return {
      isShow: this.openModal, //  是否打开弹框
      spinning: false,
      formItemLayout: {
        labelCol: { span: 4 },
        wrapperCol: { span: 17 }
      },
      form: {
        promotionRuleType: 'BUY_PROD_GIVE_MONEY', // 买产品送采购额
        description: '',
        gateFlag: '0', // 门槛
        gateType: undefined,
        gateAmount: undefined,
        quotaAmount: undefined,
        regularSameFlag: '0', // 满赠规则  不同款商品
        regularAmount: undefined,
        giveAmount: undefined,
        restrictCategory: '',
        accrualFlag: '1', // 数量叠加
        minOrderFlag: '0', // 起订金额
        minOrderAmount: undefined,
        upperLimitFlag: '0', // 活动经费上限
        upperLimitAmount: undefined,
        scopeFlag: '1'
      },
      rules: {
        description: [ { required: true, message: '请输入规则简称', trigger: 'blur' } ],
        gateFlag: [ { required: true, message: '请选择规则门槛', trigger: 'change' } ],
        regularAmount: [{ required: true, message: '请输入满赠规则', trigger: 'blur' }],
        accrualFlag: [{ required: true, message: '请选择数量是否叠加', trigger: 'change' }],
        minOrderFlag: [{ required: true, message: '请选择订单起订金额', trigger: 'change' }],
        upperLimitFlag: [{ required: true, message: '请选择活动经费上限', trigger: 'change' }],
        scopeFlag: [{ required: true, message: '请选择采购额适用范围', trigger: 'change' }]
      },
      chooseVal: 'a',
      scaleNum: 0,
      openGuideModal: false
    }
  },
  methods: {
    // 导入
    closeGuideModel () {
      this.openGuideModal = false
    },
    hanldeOk (arr) {
      const resultArr = []
      arr.forEach(item => {
        const obj = {
          productCode: item.productCode,
          productSn: item.product.productSn
        }
        resultArr.push(obj)
      })
      const name = this.chooseVal == 'a' ? 'cill' : this.chooseVal == 'b' ? 'normalPrice' : 'offer'
      this.$refs[name + 'Product'].importRow(resultArr)
    },
    // 计算百分比
    calculatePrice () {
      const _this = this
      if (_this.form.regularAmount && _this.form.giveAmount) {
        _this.scaleNum = ((_this.form.giveAmount / _this.form.regularAmount) * 100).toFixed(2)
      } else {
        _this.scaleNum = 0
      }
    },
    // 门槛切换  tab 按钮默认显示问题
    changeGateFlag (e) {
      if (this.chooseVal != 'c') {
        if (e.target.value == '0') {
          this.chooseVal = 'b'
          this.form.gateType = undefined
          this.form.gateAmount = undefined
          this.form.quotaAmount = undefined
        } else {
          this.chooseVal = 'a'
        }
      }
    },
    changeGateTypeFlag (val) {
      this.form.gateType = val
      this.form.gateAmount = undefined
      this.form.quotaAmount = undefined
    },
    //  保存
    handleSave () {
      const _this = this
      this.$refs.ruleForm.validate(valid => {
        if (valid) {
          // 验证必填
          if (_this.form.gateFlag == '1') {
            if (!_this.form.gateType) {
              _this.$message.warning('请选择规则门槛设置类型！')
              return
            }
            if (!_this.form.gateAmount) {
              _this.$message.warning('规则门槛条件不能为空！')
              return
            }
            if (_this.form.gateType === 'FIXED_AMOUNT' && !_this.form.quotaAmount) {
              _this.$message.warning('规则门槛条件不能为空！')
              return
            }
          }
          if (!_this.form.regularAmount || !_this.form.giveAmount) {
            _this.$message.warning('满赠规则条件不能为空！')
            return
          }

          if (_this.form.minOrderFlag == 1 && !_this.form.minOrderAmount) {
            _this.$message.warning('请输入订单起订限制金额数！')
            return
          }
          if (_this.form.upperLimitFlag == 1 && !_this.form.upperLimitAmount) {
            _this.$message.warning('请输入活动经费上限金额！')
            return
          }
          const form = JSON.parse(JSON.stringify(_this.form))
          let rowFlag1, rowFlag2, rowFlag3
          if (form.gateFlag == '1') {
            form.gateProductList = this.$refs.cillProduct.getResultVal()
            form.gateAmount = form.gateType === 'RATIO_AMOUNT' ? form.gateAmount / 100 : form.gateAmount
            if (form.gateProductList.length == 0) {
              _this.$message.warning('请添加门槛产品！')
              return
            } else {
              const qtyFlag = form.gateProductList.some(newCon => { return (!newCon.unitType || !newCon.unitQty) })
              if (qtyFlag) {
                _this.$message.warning('订单起订量设置不能为空！')
                return
              }
              rowFlag1 = _this.isJudge(form.gateProductList)
            }
          } else {
            form.gateProductList = []
            form.gateAmount = ''
            form.quotaAmount = ''
            form.gateType = undefined
          }

          form.regularProductList = this.$refs.normalPriceProduct.getResultVal()
          // 判断表格必填
          if (form.regularProductList.length == 0) {
            _this.$message.warning('请添加正价产品！')
            return
          } else {
            const qtyFlag = form.regularProductList.some(newCon => { return (!newCon.unitType || !newCon.unitQty) })
            if (qtyFlag) {
              _this.$message.warning('订单起订量设置不能为空！')
              return
            }
            rowFlag3 = _this.isJudge(form.regularProductList)
          }

          if (form.scopeFlag == '0') {
            form.giftProductList = this.$refs.offerProduct.getResultVal()
            if (form.giftProductList.length == 0) {
              _this.$message.warning('请添加促销产品！')
              return
            }
            rowFlag2 = _this.isJudge(form.giftProductList)
          } else {
            form.giftProductList = []
          }

          if (rowFlag1 || rowFlag2 || rowFlag3) {
            _this.$message.warning('请选择产品分类、品牌或产品！')
            return
          }
          form.promotionSn = _this.promotionSn
          _this.spinning = true
          promotionSave(form).then(res => {
            if (res.status == 200) {
              _this.$message.success(res.message)
              setTimeout(() => {
                _this.isShow = false
                _this.$emit('ok')
                _this.spinning = false
              }, 1000)
            } else {
              _this.spinning = false
            }
          })
        } else {
          return false
        }
      })
    },
    // 判断品牌，分类，产品其中一个必填
    isJudge (list) {
      let flag = null
      list.forEach(con => {
        if (con.productThisList) {
          if (con.productThisList.length > 0) {
            flag = false
          } else {
            if ((con.productTypeList && con.productTypeList.length > 0) || (con.productBrandList && con.productBrandList.length > 0)) {
              flag = false
            } else {
              flag = true
            }
          }
        } else {
          if ((con.productTypeList && con.productTypeList.length > 0) || (con.productBrandList && con.productBrandList.length > 0)) {
            flag = false
          } else {
            flag = true
          }
        }
      })
      return flag
    },
    // 重置表格
    resetSearchForm () {
      this.form = {
        promotionRuleType: 'BUY_PROD_GIVE_MONEY', // 买产品送采购额
        description: '',
        gateFlag: '0', // 门槛
        gateType: undefined,
        gateAmount: undefined,
        quotaAmount: undefined,
        regularSameFlag: '0', // 满赠规则  不同款商品
        regularAmount: undefined,
        giveAmount: undefined,
        restrictCategory: '',
        accrualFlag: '1', // 数量叠加
        minOrderFlag: '1', // 起订金额
        minOrderAmount: undefined,
        upperLimitFlag: '1', // 活动经费上限
        upperLimitAmount: undefined,
        scopeFlag: undefined,
        gateProductList: undefined,
        giftProductList: undefined,
        regularProductList: undefined
      }
      this.$nextTick(() => {
        this.$refs.ruleForm.resetFields()
        this.$refs.cillProduct.reSetTableData()
        this.$refs.normalPriceProduct.reSetTableData()
        this.$refs.offerProduct.reSetTableData()
      })
    },
    // 获取编辑详情
    getDetail () {
      const _this = this
      getRuleDetail({ sn: this.itemSn }).then(res => {
        if (res.status == 200) {
          this.chooseVal = res.data.gateFlag == '0' ? 'b' : 'a'
          const resultObj = res.data
          if (resultObj.gateFlag === '1') {
            resultObj.gateAmount = resultObj.gateType === 'RATIO_AMOUNT' ? resultObj.gateAmount * 100 : resultObj.gateAmount
          }
          // 重新组成保存数据
          if (resultObj.gateProductList && resultObj.gateProductList.length > 0) {
            resultObj.gateProductList = _this.newData(resultObj.gateProductList)
            this.$refs.cillProduct.setTabVal(resultObj.gateProductList)
          }
          if (resultObj.regularProductList && resultObj.regularProductList.length > 0) {
            resultObj.regularProductList = _this.newData(resultObj.regularProductList)
            this.$refs.normalPriceProduct.setTabVal(resultObj.regularProductList)
          }
          if (resultObj.giftProductList && resultObj.giftProductList.length > 0) {
            resultObj.giftProductList = _this.newData(resultObj.giftProductList)
            this.$refs.offerProduct.setTabVal(resultObj.giftProductList)
          }
          this.form = { ...this.form, ...resultObj }
        }
      })
    },
    newData (list) {
      list.forEach(con => {
        // 品牌
        if (con.productBrandList) {
          const brandList = []
          con.productBrandList.forEach(item => {
            item.brandName = item.productBrandName
            const brandObj = {
              productBrandSn: item.productBrandSn
            }
            brandList.push(brandObj)
          })
          con.productBrandArr = con.productBrandList
          con.productBrandList = brandList
        }
        // 分类
        if (con.productTypeList) {
          const typeList = []
          con.productTypeList.forEach(item => {
            const typeObj = {}
            item.title = ''
            const num = 3
            for (var i = 0; i < num; i++) {
              if (item['productTypeName' + (i + 1)]) {
                // item.title += item['productTypeName' + (i + 1)] + (item['productTypeName' + (i + 1)] ? '/' : '')
                typeObj['productTypeSn' + (i + 1)] = item['productTypeSn' + (i + 1)] ? item['productTypeSn' + (i + 1)] : ''
              }
            }
            // item.title = item.title.slice(0, item.title.length - 1)
            if (item.productTypeName3) {
              item.title = item.productTypeName2 + '/' + item.productTypeName3
            } else if (!item.productTypeName3 && item.productTypeName2) {
              item.title = item.productTypeName2
            } else {
              item.title = item.productTypeName1
            }
            item.id = item.productTypeSn3 ? item.productTypeSn3 : item.productTypeSn2 ? item.productTypeSn2 : item.productTypeSn1
            typeList.push(typeObj)
          })
          con.productTypeArr = con.productTypeList
          con.productTypeList = typeList
        }
        // 产品
        if (con.productThisList) {
          const productList = []
          con.productThisList.forEach(item => {
            const productObj = {
              productCode: item.productCode,
              productSn: item.productSn
            }
            productList.push(productObj)
          })
          con.productThisList = productList
        }
      })
      return list
    }
  },
  watch: {
    //  父页面传过来的弹框状态
    openModal (newValue, oldValue) {
      this.isShow = newValue
    },
    //  重定义的弹框状态
    isShow (newValue, oldValue) {
      if (!newValue) {
        this.$emit('close')
        this.resetSearchForm()
      } else {
        if (this.itemSn) {
          this.getDetail()
        } else {
          this.chooseVal = this.form.gateFlag == '0' ? 'b' : 'a'
        }
      }
    }
  }
}
</script>

<style lang="less" scoped>
  .promotionList-basicInfo-modal{
    /deep/.ant-modal-body {
      padding: 40px 40px 24px;
      max-height: 745px !important;
      overflow-y: scroll !important;
    }
    .ant-radio-button-wrapper{
      width:80px;
      text-align: center;
    }
    .ant-form-item{
      margin-bottom:5px;
    }
    .buyerBox{
      border:1px solid #d9d9d9;margin-top:10px;border-radius:4px;padding:4px 10px;background:#f2f2f2;max-height:130px;overflow-y:scroll;
    }
    .btn-cont {
      text-align: center;
      margin: 35px 0 10px;
    }
    .flex{
      display:flex;
      align-items:center;
      justify-content:space-between;
    }
  }

</style>
